declare filename "weirdPhaser.dsp"; declare name "weirdPhaser"; declare name "Weird Phaser";
declare description "Stereo Phaser based on SSB Modulation";
declare author "Oli Larkin (contact@olilarkin.co.uk)";
declare copyright "Oliver Larkin";
declare version "0.1";
declare licence "GPL";

//import("IIRHilbert.lib");
//import("stdfaust.lib");

mix = 0.5;
maxfeedback = 0.7;
SR = 44100;
PI = 3.1415926535897932385;

rate = hslider("rate", 0, 0., 1, 0.001);
rateScalar = hslider("rate_scalar", 1., 1., 40., 0.001);
offset = hslider("L-R_offset", 0., 0., 1., 0.001) * 0.5;
fbk = hslider("feedback", 0., 0, 1., 0.01) : *(maxfeedback) : smooth(tau2pole(0.005));

if(cond,then,else) = select2(cond,else,then);

smooth(s) = *(1.0 - s) : + ~ *(s);
EPSILON = 2.2204460492503131e-016;

tau2pole(tau) = if(clipCond, 0.0, exp(-1.0/(tauCenterClipped*float(SR)))) with {
    clipCond = abs(tau)<EPSILON;
    tauCenterClipped = if(clipCond, 1.0, tau); // 1.0 can be any nonzero value (not used)
};

hilbertef(x) = real(x), imag(x)
with {
  biquad(a1,a2,b0,b1,b2) = + ~ conv2(a1,a2) : conv3(b0,b1,b2) 
  with {
    conv3(k0,k1,k2,x) = k0*x + k1*x' + k2*x'';
    conv2(k0,k1,x) = k0*x + k1*x';
  };
  real = biquad(-0.02569, 0.260502, -0.260502, 0.02569, 1) 
        : biquad(1.8685, -0.870686, 0.870686, -1.8685, 1) ;
  imag = biquad(1.94632, -0.94657, 0.94657, -1.94632, 1) 
      : biquad(0.83774, -0.06338, 0.06338,  -0.83774, 1) ;
};

frac(n) = n - floor(n);
decimal = frac;

ssbfreqshift(x, offset) = (+ : negative) ~ (*(fbk) : clip(-1, 1))
with {
  negative(x) = real(x)*cosv - imag(x)*sinv;
  positive(x) = real(x)*cosv + imag(x)*sinv;
  real(x) = hilbert(x) : _ , !;
  imag(x) = hilbert(x) : ! , _;
  phasor = fmod(((rate*rateScalar)/float(SR) : (+ : decimal) ~ _)+offset, 1.) * (2*PI);
  sinv = sin(phasor);
  cosv = cos(phasor);
  hilbert = hilbertef;
  clip(lo,hi) = min(hi) : max(lo);
};

process(l,r) = l,r <: *(1-mix), *(1-mix), ssbfreqshift(l, 0.)*mix, ssbfreqshift(r, offset)*mix :> _,_;